/* Copyright (c) 1993-2000, Spirent Communications of Calabasas, Inc.     */
/* Copyright (c) 1993-1999, Netcom Systems, Inc.					*/

#ifndef __atmapi_h
#define __atmapi_h

#if   defined WIN32
#include <pshpack4.h>
#endif

/* This API currently only supports the PVC Load Test... */

#include "atmsgapi.h"      /**** extended the ATMSignalingStruct  ****/
#include "testcmmn.h"

#include "ettypes.h"

#define	SUCCESS	0

/* Test Error code... */
#define TEST_ATM_STREAM_SETUP_ERR                        -130
#define TEST_ATM_FRAME_SETUP_ERR                         -131
#define TEST_ATM_ARP_CONN_NOT_ESTABLISHED                -132
#define TEST_ATM_ELAN_NOT_REGISTERED                     -133



/* Test Types */
#define	TEST_ATM_PVC_LOAD					10
#define	TEST_ATM_PVC_THROUGHPUT			11
#define	TEST_ATM_PVC_PACKETLOSS			12
#define	TEST_ATM_PVC_LATENCY				13
#define	TEST_ATM_PVC_GOODPUT				14
#define	TEST_ATM_PVC_POLICING			15
#define	TEST_ATM_INSVC						16


#ifdef __cplusplus
extern "C" {
#endif

#if defined WIN16 || defined WIN32
typedef int (WINAPI * ATMVCStatusCallbackFunc)(TestStatus *pTestStatus, ATMSignalingStruct *pIntVC);
typedef int (WINAPI * ATMVCErrorCallbackFunc)(char *pError);
#else
typedef int (*ATMVCStatusCallbackFunc)(TestStatus *pTestStatus, ATMSignalingStruct *pIntVC);
typedef int (*ATMVCErrorCallbackFunc)(char *pError);
#endif

#ifdef __cplusplus
};
#endif


#ifdef __cplusplus
extern "C" {
#endif

int DLL_EXPORT  NSATMVCTestStart(short iTestType, TestTypeStruct *pTestType,
                     ATMSignalingStruct *pVC, ATMPvcSvcTestSetup *pTestSetup);
int DLL_EXPORT  NSATMVCTestStartVB(short iTestType,  TestTypeStruct *pTestType,
                     ATMSignalingStruct *pVC, ATMPvcSvcTestSetup *pTestSetup );
int DLL_EXPORT  NSATMVCTestReset(short iTestType);
int DLL_EXPORT  NSATMVCTestStop(short iTestType);
int DLL_EXPORT  NSATMVCTestReport(short iTestType, char *pszReport);
int DLL_EXPORT  NSATMVCGetReportFilename(char *filename);

#ifdef __cplusplus
};
#endif

#if   defined WIN32
#include <poppack.h>
#endif

#endif

