/************************************************************************
 *	Netcom Systems, Inc.

 *	file: l2items.h
 *	POS SmartCard Configuration definitions

 *	Copyright (c) 1993-2000, Spirent Communications of Calabasas, Inc.
 *	Copyright (C) 1993-1999. All Rights Reserved.
 ************************************************************************/

#ifndef  _L2ITEMS_H_
#define  _L2ITEMS_H_

/************** This file is used by POS and LAN6201 cards ***********************/

#include "l3items.h"
#include "ettypes.h"

#ifndef POS_CARD_BASE 
#define POS_CARD_BASE 0x6100
#endif

/*********************************************************************************
 * Structure:   L2StatsInfo
 * iType1:      L2_READ_COUNTERS
 * Function:    HTGetStructure
 * L2StatsInfo Description: Get transmit and receive counter 
***********************************************************************************/
typedef struct tagL2StatsInfo
{
	U64				u64TxFrame;			/* No. of transmitted frames        */
	U64				u64TxByte;			/* No. of transmitted bytes         */
	U64				u64TxTrigger;		/* No. of  transmitted triggers     */
	unsigned long	ulTxLatency;		/* Tx latency counter (50ns units)  */
	U64				u64RxFrame;			/* No. of received frames           */
	U64				u64RxByte;			/* No. of received bytes            */
	U64				u64RxTrigger;		/* No. of receive triggers          */
	unsigned long	ulRxLatency;		/* Rx latency counter (50ns units)  */
	U64				u64RxCRCError;		/* No. of frames with CRC errors    */
	U64				u64RxOversize;		/* No. of oversized frames          */
	U64				u64RxUndersize;		/* No. of undersized frames         */
} L2StatsInfo;

#define L2_READ_COUNTERS		(POS_CARD_BASE + 0x0010)

/*********************************************************************************
 * Structure:   L2RateInfo
 * iType1:      L2_READ_RATES
 * Function:    HTGetStructure
 * L2RateInfo Description: get transmit and receive rate 
***********************************************************************************/
typedef struct tagL2RateInfo
{
	unsigned long	ulTxFrameRate;		/* transmitted frames per second     */
	unsigned long	ulTxByteRate;
	unsigned long	ulTxTriggerRate;
	unsigned long	ulRxFrameRate;
	unsigned long	ulRxByteRate;
	unsigned long	ulRxTriggerRate;
	unsigned long	ulRxCRCErrorRate;
	unsigned long	ulRxOversizeRate;
	unsigned long	ulRxUndersizeRate;
} L2RateInfo;

#define L2_READ_RATES			(POS_CARD_BASE + 0x0011)


#endif
