/*
	Copyright (c) 1993-2002, Spirent Communications of Calabasas, Inc.
	Netcom Systems, Inc.
	Copyright (C) 1993-1999. All Rights Reserved.
*/
#ifndef __NTPITEMS_H__
#define __NTPITEMS_H__

#include "et1000.h"

#define MAX_NTP_PEERS           5          /* Maximum number of peers per client */
#define MAX_NTP_STRING_SIZE     100        

#define NS_NTP_CLIENT_DISABLE   0
#define NS_NTP_CLIENT_ENABLE    1
#define MIN_FFOM_LIMIT          0
#define MAX_FFOM_LIMIT          3
#define MIN_TFOM_LIMIT          0
#define MAX_TFOM_LIMIT          9

typedef struct tagNSNTPFOMInfo {
    unsigned long ulCompositeFOM;           /* 1=ready, 0=not_ready                     */
    unsigned long ulCurrentFFOM;            /* range 0-3                                */
    unsigned long ulFFOMLimit;              /* range 0-3                                */
    unsigned long ulCurrentTFOM;            /* range 0-9                                */
    unsigned long ulTFOMLimit;              /* range 0-9                                */
} NSNTPFOMInfo;

typedef struct tagNSNTPPeerListInfo {
    unsigned long ulCount;                    /* number of peers */
	NSIPAddress   addrs[MAX_NTP_PEERS];
} NSNTPPeerListInfo;

typedef struct tagNSNTPStatusInfo {
	char szName[MAX_NTP_STRING_SIZE];
	char szValue[MAX_NTP_STRING_SIZE];
} NSNTPStatusInfo;


#endif /* __NTPITEMS_H__ */


