/*
	Netcom Systems, Inc.
	Copyright (C) 1993-1999. All Rights Reserved.
*/
#ifndef __testapi_h
#define __testapi_h

#if   defined WIN32
#include <pshpack4.h>
#endif

#include "ettypes.h"
#include "testcmmn.h"

/* Test Types */

#define		TEST_NONE		 			0
#define		TEST_THROUGHPUT 			1
#define		TEST_LATENCY				2
#define		TEST_PACKETLOSS 			3
#define		TEST_BACK2BACK				4
#define		TEST_MESH					5
#define		TEST_TRTHROUGHPUT			6

/* Speed defines */

#define 		CARD_SPEED_10M				0
#define		CARD_SPEED_100M 			1
#define		CARD_SPEED_4M				0
#define		CARD_SPEED_16M				1

/* address length defines */

#define 		MAC_ADDRESS_LEN  			6
#define		IP_ADDRESS_LEN				4
#define		IPX_ADDRESS_LEN  			4

/* Learning packets Mode... */

#define		LEARNING_NEVER				0
#define		LEARNING_ONCE				1
#define		LEARNING_EVERYTRIAL 		2
#define		LEARNING_EVERYNTRIALS	3

/* Protocol defines */

#define     FILL_0						0
#define     FILL_1						1
#define     FILL_5						2
#define     FILL_A						3
#define     FILL_C						4
#define 		PROTOCOL_ZERO				0
#define		PROTOCOL_ONE				1
#define		PROTOCOL_IP					5
#define 		PROTOCOL_UDP				6
#define 		PROTOCOL_IPX				7

#define		MAX_NEXTHOP					10

// Errors occuring in the TCL interface
#define NSTCL_PARAMETER_TYPE		-501
#define NSTCL_INVALID_MSG_FUNC		-502
#define NSTCL_PARAMETER_RANGE		-503
#define NSTCL_STRUCT_NOT_DEFINED	-504

typedef struct		tagPortPairStruct 
 {
 PortStructure 	TxPort;    /* configuration of the first */
                             /* port in the port pair */
 PortStructure 	RxPort;    /* configuration of the second */
                             /* port in the port pair */
 }	PortPairStruct;


#ifdef __cplusplus
extern "C" {
#endif

#if defined WIN16 || defined WIN32
/*
typedef int (WINAPI * StatusCallbackFunc)(TestStatus *pTestStatus);
typedef int (WINAPI * ErrorCallbackFunc)(char *pError);
*/
typedef int (CALLBACK * StatusCallbackFunc)(TestStatus *pTestStatus);
typedef int (CALLBACK * ErrorCallbackFunc)(char *pError);
#else
typedef int (*StatusCallbackFunc)(TestStatus *pTestStatus);
typedef int (*ErrorCallbackFunc)(char *pError);
#endif

int DLL_EXPORT  	NS1242TestStart(int iTestType, PortPairStruct *pPortPair, int iTestPairs, TestSetup *pTestSetup
											, StatusCallbackFunc StatusCallBack, ErrorCallbackFunc ErrorCallBack);
int DLL_EXPORT  	NS1242TestStartVB(int iTestType, PortPairStruct *pPortPair, int iTestPairs, TestSetup *pTestSetup);
int DLL_EXPORT  	NS1242TestReset(int iTestType);
int DLL_EXPORT   	NS1242TestStop(int iTestType);
int DLL_EXPORT 	NS1242TestReport(int iTestType, char *pszReport);
int DLL_EXPORT 	NS1242GetReportFilename(char *filename);
int DLL_EXPORT NS1242GetAPIVersion(char* pszDescription, char * pszVersion );

#ifdef __cplusplus
};
#endif

#if   defined WIN32
#include <poppack.h>
#endif

#endif

