/*****************************************************************************
 * wanitems.h
 * WAN card definitions (WAN and Frame Relay)
 *
 * Copyright (c) 1993-2000, Spirent Communications of Calabasas, Inc.
 * Copyright (c) 1996-1999, Netcom Systems, Inc.
 ****************************************************************************/

#ifndef _WANITEMS_H_
#define _WANITEMS_H_

#define WAN_DS3_SHORT_BUILDOUT		0
#define WAN_DS3_LONG_BUILDOUT			1
#define WAN_DS1_0_TO_133_BUILDOUT	2		/* 0 to 133 feet		*/
#define WAN_DS1_133_TO_266_BUILDOUT	3		/* 133 to 266 feet	*/
#define WAN_DS1_266_TO_399_BUILDOUT	4		/* 266 to 399 feet	*/
#define WAN_DS1_399_TO_533_BUILDOUT	5		/* 399 to 533 feet	*/
#define WAN_DS1_533_TO_655_BUILDOUT	6		/* 533 to 655 feet	*/
#define WAN_DS1_N7X5_DB_BUILDOUT		7		/* -7.5 dB of attenuation	*/
#define WAN_DS1_N15_DB_BUILDOUT		8		/* -15 dB of attenuation	*/
#define WAN_DS1_N22X5_DB_BUILDOUT	9		/* -22.5 dB of attenuation	*/
#define WAN_E1_BUILDOUT					20

#define WAN_DS1_AMI_ENCODING			0
#define WAN_DS1_B8ZS_ENCODING			1

#define WAN_DS1_D4_LINE_FRAMING		0
#define WAN_DS1_ESF_LINE_FRAMING		1

#define WAN_E1_AMI_ENCODING			0
#define WAN_E1_HDB3_ENCODING			1

/* DS1 alarm flags */
#define WAN_DS1_E1_LOCD_ALARM				 	0x0001
#define WAN_DS1_E1_OOF_ALARM				 	0x0002
#define WAN_DS1_E1_LOS_ALARM				 	0x0004
#define WAN_DS1_E1_YELLOW_ALARM			 	0x0008
#define WAN_DS1_E1_AIS_ALARM				 	0x0010
#define WAN_DS1_E1_B8ZS_ALARM				 	0x0020
#define WAN_DS1_E1_EXCESS_ZEROS_ALARM	 	0x0040
#define WAN_DS1_E1_PLCP_OOF_ALARM			0x0080
#define WAN_DS1_E1_PLCP_LOF_ALARM			0x0100
#define WAN_DS1_E1_PLCP_YELLOW_ALARM		0x0200
#define WAN_DS1_E1_SEV_ERROR_FRAME_ALARM 	0x0400

#endif
/* _WANITEMS_H_ */
