/*
 *	sample code for TI TLK110 functions  
 *                                       
 *	TI TLK110 Ethernet transceiver.     
 *	                                     
 *  The code was written in C using Microsoft Visual Studio 6.0 IDE
 *  Debugging was done by interfacing Spirent SmartBits-200/2000(SMB-200/2000).
 *
 *  main.c is for debugging and demonstration.
 *  main (main.c) calls the various functions, sets their input variables and  
 *  Handles their output; its purpose is for debugging and demonstration.
 *
 */
	                                     
	                                    





#include < stdio.h > 
#include < string.h >
#include "registers.h"
#include "status.h"
#include "settings.h"
#include "loopback.h"
#include "power_save.h"
#include "prbs.h"
#include "reset.h"
#include "ALCD.h"
#include "Resource files/et1000.h"  
#include "TDR.h"


void main()
{

///////////////////////////////////////////////////////////////////	
//    varaiable declarations	                                 //
//                                                               //
///////////////////////////////////////////////////////////////////

    //general variables
      int error = 0;
	  int phy_id =1; //phy_identification
	
	//link setup variables
	  enum Set_link_behaviors_t Set_link_behavior;
	  enum Set_speeds_t Set_speed;
	  enum Set_duplexes_t Set_duplex;
	  enum Set_MDIs_t Set_mdi;
    
	//loopback variables
	  enum loopback_modes_t loopback_mode;

	//power_save variable
	  enum power_save_modes_t power_save_mode; 

	//prbs variables
      int set_packet_length;
      int set_packet_IPG;
	  int prbs_lock, prbs_sync_loss, prbs_busy;
	  enum prbs_generator_enable_t prbs_generator_enable;
	  enum lock_and_clear_prbs_counters_t lock_and_clear_prbs_counters;
	  enum prbs_count_mode_t prbs_count_mode; 
      prbs_counters prbs_check_counters;

	//ALCD variables
	  int result_alcd;

    //status
      status_phy status_out;

    //TDR variables
      int  reflection[10];
	  double  impedance[10];
	  enum averaging_t averaging;
	  int i;
	  int channel_peak_index;
	  char *channel;
      TDR_status TDR_status_main;

///////////////////////////////////////////////////////////////////	
//    establish link with smartbit (debug)                       //
//                                                               //
///////////////////////////////////////////////////////////////////
  
	error = ETSocketLink("137.167.24.24", 16385);
	if (error < 0)
	{
		printf("Error linking to chassis: %d \n",error);
		error = 0;
	}
 
///////////////////////////////////////////////////////////////////	
//    main function calls	                                     //
//                                                               //
///////////////////////////////////////////////////////////////////


	// reset
	   printf("%%   RESET PHY  %% \n");
	   error = reset_phy(phy_id);
       Sleep(500);
       printf("%%%%%%%%%%%%%%%%%% \n");

	// link_setup
	   printf("%%   LINK_SETUP  %% \n");
	   Set_link_behavior = AUTO_NEG;
	   Set_speed = SPD_100;
	   Set_duplex = FD;
	   Set_mdi = AUTO_MDI;
       error = link_setup(phy_id,Set_link_behavior,Set_speed,Set_duplex,Set_mdi);
        	if (error < 0)
			{
		         printf("Error link_setup: %d \n",error);
				 error = 0;
			}
       Sleep(1000);
       printf("%%%%%%%%%%%%%%%%%% \n");

     //status of the phy
       printf("%%   STATUS OF THE PHY  %% \n");
	   Sleep(4000);
       error  = status(phy_id, &status_out);
        	if (error < 0)
			{
		         printf("Error status: %d \n",error);
				 error = 0;
			}
            else
            {
	        switch(status_out.link_status)
			{
			case LINK_UP:
				printf("link is up \n");
			    break;

			case LINK_DOWN:
				printf("link is down \n");
			    break;

			default: //link_down
				printf("link is down \n");
			    break;
			}

            switch(status_out.speed_status)
			{
			case SPD_100:
				printf("speed 100BT \n");
			    break;

			case SPD_10:
				printf("speed 10BT \n");
			    break;

			default: //SPD_10
				printf("SPD_10 \n");
			    break;
			}

            switch(status_out.duplex_status)
			{
			case FD:
				printf("full duplex \n");
			    break;

			case HD:
				printf("half duplex \n");
			    break;

			default: //HD
				printf("half duplex \n");
			    break;
			}

            switch(status_out.pair_swap)
			{
			case MDIX:
				printf("MDIX \n");
			    break;

			case MDI:
				printf("MDI \n");
			    break;

			default: //MDI
				printf("MDI \n");
			    break;
			}
 
            }
printf(" \n");
printf("    %%%%%%%%%%%%%%%%%%%%% \n");
	   
	   	   
	   
	   // loopback
       printf("%%   LOOPBACK  %% \n");
       loopback_mode = LOOPBACK_NORMAL;
       //error = loopback(phy_id,loopback_mode);
        	if (error < 0)
			{
		         printf("Error loopback: %d \n",error);
				 error = 0;
			}
       printf("%%%%%%%%%%%%%%%%%% \n");

    // power_save
       printf("%%   POWER SAVE  %% \n");
       //power_save_mode = POWER_NORMAL;
	   //error = power_save(phy_id,power_save_mode);
        	if (error < 0)
			{
		         printf("Error power_save: %d \n",error);
				 error = 0;
			}
       printf("%%%%%%%%%%%%%%%%%% \n");

    //prbs_generator
      printf("%%   PRBS GENERATOR  %% \n");
	  set_packet_length = 1000;  //Length of PRBS packets in bytes
      set_packet_IPG = 90;      //Inter-packet gap (in bytes) between PRBS packets
      prbs_count_mode = CONTINUOUS;//CONTINUOUS;
      prbs_generator_enable = ENABLE;//DISABLE
	  //error = prbs_generator(phy_id, prbs_generator_enable, set_packet_length,set_packet_IPG, prbs_count_mode);
        	if (error < 0)
			{
		         printf("Error prbs_generator: %d \n",error);
				 error = 0;
			}
      Sleep(500);
      printf("%%%%%%%%%%%%%%%%%% \n");

   //prbs_status
     printf("%%   PRBS STATUS  %% \n");
     //error = prbs_status(phy_id, &prbs_lock, &prbs_sync_loss, &prbs_busy);
        	if (error < 0)
			{
	 	         printf("Error prbs_status: %d \n",error);	
				 error = 0;
			}
            else
            {
				if (prbs_lock == 1)
				{
                 printf("PRBS checker is locked on received byte stream \n");
				}
				else
				{
                 printf("PRBS checker is not locked \n");
				}
				if (prbs_sync_loss == 1)
				{
                 printf("PRBS checker has lost sync \n");
				}
				else
				{
                 printf("PRBS checker has not lost sync \n");
				}
				if (prbs_busy == 1)
				{
                 printf("Packet generator is busy \n");
				}
				else
				{
                 printf("Packet generator is not busy \n");
				}
            }
     printf("%%%%%%%%%%%%%%%%%% \n");

   //prbs_checker
	 printf("%%   PRBS CHECKER  %% \n");
  	 lock_and_clear_prbs_counters = LOCK_AND_CLEAR; 
     //error = prbs_checker(phy_id, lock_and_clear_prbs_counters, &prbs_check_counters);
        	if (error < 0)
			{
	 	         printf("Error prbs_checker: %d \n",error);	
				 error = 0;
			}
            else
            {
                 printf("error counter %x \n", prbs_check_counters.error_counter );
            }
     printf("%%%%%%%%%%%%%%%%%% \n");

   //ALCD (Active Link Cable Diagnostic)
	 printf("%%   ALCD  %% \n");
     error = ALCD(phy_id, &result_alcd);
        	if (error < 0)
			{
	 	         printf("Error prbs_checker: %d \n",error);
				 error = 0;
			}
            else
            {
				if (result_alcd <0)
				{
					printf("alcd_cable_length: no info \n");
				}
				else
				{
                    printf("alcd_cable_length: %d \n", result_alcd);
				}

            }
     printf("%%%%%%%%%%%%%%%%%% \n"); 
      
   //TDR
	 printf("%%   TDR  %% \n");
	 averaging = DISABLE_AVG; //disable or enable averaging		
     error  = TDR( phy_id, reflection, impedance, averaging, &TDR_status_main);
	 
     if (error < 0)
	 {
          printf("TDR error \n");
		  error = 0;
	 }
	 else
	 {

          printf("                  reflection(m)    impedance \n");
          printf("                  --\n");
          for (i=0;i<10;i++)
		  {

	           //select channel to present
	           if (i < 5)
			   {
		            channel = "channel_A";
		            channel_peak_index = i;
			   }
	           else
			   {
		            channel = "channel_B";
		            channel_peak_index = i-5;
			   }

               if (i == 5)
			   {
		            printf("\n"); //space between channels
			   }



               switch(reflection[i])
			   {
	                case REFLECTION_LESS_THAN_3M:
		                 printf("%s peak %d |    <3m             ",channel, channel_peak_index);
	                break;

					default:
						if ( reflection[i] < -7 || reflection[i] > 250) //undefined number
						{
                         printf("%s peak %d |    no info         ",channel, channel_peak_index);
						}
						else
						{
			             printf("%s peak %d |    %d              ",channel, channel_peak_index ,reflection[i]);
						}
                    break;
			   }


 		             printf("%lf\n", impedance[i]);



		  }  


          printf("                  --\n");
	

		 }
         printf("%%%%%%%%%%%%%%%%  additional TDR Information %%%% \n"); 
        
	        switch(TDR_status_main.open_cha_status)
			{
			case 1:
				printf("cha is open \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.open_chb_status)
			{
			case 1:
				printf("chb is open \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.cross_cha_status)
			{
			case 1:
				printf("found cross between ch_a and ch_b  \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.cross_chb_status)
			{
			case 1:
				printf("found cross between ch_a and ch_b \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.terminated_cha_status)
			{
			case 1:
				printf("cha is terminated \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.terminated_chb_status)
			{
			case 1:
				printf("chb is terminated \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.short_cha_status)
			{
			case 1:
				printf("cha is shorted \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}
	        switch(TDR_status_main.short_chb_status)
			{
			case 1:
				printf("chb is shorted \n");
			    break;

			case 0:				
			    break;

			default: //link_down			
			    break;
			}

         printf("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \n"); 
 
	ETUnLink();


}

