
/*                                             
 * this function polls a specific bit           
 *                                             
 * until timeout or desired value
 * it is used by the cable diagnostic functions (ALCD and TDR)
 * to wait for  a done signal.
 *
 */

#include <math.h>
#include "registers.h"
#include "loopback.h"
#include "read_write.h"
#include "Resource files/et1000.h"
#include "ALCD.h"


int polling(int phy_id, int address, int bit_num, unsigned long poll_time)
{
	
	int rbit = 0; 
	int power_int;
	double power;
	unsigned long timenow = 0;

    timenow = timeGetTime(); //get current time


	do {
		rbit = phy_read(phy_id, address);  
		if (rbit < 0)// error
		{
		return -1;
		}
		power =	pow(2,bit_num);
        power_int = (int) (power);
	    rbit = (rbit / power_int) & 0x1; //the specific bit we are polling
        
		if ((timeGetTime() - timenow) > poll_time)
		{
            return -1;  //Timeout
		}

	}while(rbit == 0);
		
     
		return 1;
		
}




