
/*
 *
 * phy_write writes to phy through smb200 (smart bits) test equipment    
 *                                                                      
 * phy_read reads from phy through smb200  
 *
 * when writing/reading  to / from registers whose address space is above 1f(h) use the
 * indirect register access shown below (using registers REGCR, ADDAR)
 *
 * both these functions are implementation dependent and therefore should be changed
 * to suit your hardware/ software implementation
 */






#include < stdio.h > 
#include < string.h >
#include "registers.h"
#include "settings.h"
#include "status.h"
#include "read_write.h"
#include "Resource files/et1000.h"


   //smart bit definitions
	 int hub  = 0;
	 int slot = 2;
	 int port = 0;


int phy_write(int phy_id, int address, int data) // write to MDIO. implementation dependent !
{
		int error;
		short data_short, address_short;
		
        data_short = data;
        address_short = address;

     if (address < 32) //direct register access
	 {
         //error= HTWriteMII(unsigned int uiAddress, unsigned int uiRegister, unsigned short uiBits, int iHub, int iSlot, int iPort);
	       error= HTWriteMII(phy_id, address, data_short, hub, slot, port);

	     if (error < 0)
		 {
		    printf("Error write: %d \n", error);
            return -1;
		 }
	   return 0;
	 }
     else // address >32  indirect writing
	 {
         //error= HTWriteMII(unsigned int uiAddress, unsigned int uiRegister, unsigned short uiBits, int iHub, int iSlot, int iPort);
	       error= HTWriteMII(phy_id, REGCR,31, hub, slot, port);

	     if (error < 0)
		 {    
	  	    printf("Error write: %d \n", error);
            return -1;
		 }
       	   error= HTWriteMII(phy_id, ADDAR,address_short, hub, slot, port);

	     if (error < 0)
		 {
		    printf("Error write: %d \n", error);
            return -1;
		 }
	       error= HTWriteMII(phy_id, REGCR, 16415, hub, slot, port);

	     if (error < 0)
		 {
		    printf("Error write: %d \n", error);
            return -1;
		 }

	       error= HTWriteMII(phy_id, ADDAR, data_short, hub, slot, port);

	     if (error < 0)
		 {
		    printf("Error write: %d \n", error);
            return -1;
		 }

	   return 0;
	 }

}


int phy_read(int phy_id, int address) // read from MDIO. implementation dependent !
{
		
	short RegisterRead, address_short;
	int error,RegisterRead_int;
	
	address_short = address;
    RegisterRead_int = 0;

     if (address < 32) //direct register access
     {
        //error=HTReadMII(unsigned int uiAddress, unsigned int uiRegister, unsigned short* puiBits, int iHub, int iSlot, int iPort);
          error=HTReadMII(phy_id, address, &RegisterRead, hub, slot, port);

	    if (error < 0)
		{
		   printf("Error reading reg: %x \n",address);
		   return -1;
		}
        else
		{
           RegisterRead_int  = RegisterRead & 0xFFFF;
           printf("Read address %x  %x \n", address, RegisterRead_int);
           return RegisterRead_int; 
		}
	 }

	 else // indirect register address
	 {
        //error= HTWriteMII(unsigned int uiAddress, unsigned int uiRegister, unsigned short uiBits, int iHub, int iSlot, int iPort);
	      error= HTWriteMII(phy_id, REGCR,31, hub, slot, port);

	    if (error < 0)
		{
		   printf("Error write: %d \n",error);
           return -1;
		}

	       error= HTWriteMII(phy_id, ADDAR,address_short, hub, slot, port);

	    if (error < 0)
		{
		   printf("Error write: %d \n",error);
           return -1;
		}

	       error= HTWriteMII(phy_id, REGCR, 16415, hub, slot, port);

	    if (error < 0)
		{
		   printf("Error write: %d \n",error);
           return -1;
		}

           error=HTReadMII(phy_id, ADDAR, &RegisterRead, hub, slot, port);

	    if (error < 0)
		{
		   printf("Error reading reg: %x \n",address);
		   return -1;
		}
        else
		{
		   RegisterRead_int  = RegisterRead & 0xFFFF;
           printf("Read address %x  %x \n", address, RegisterRead_int );
           return RegisterRead_int; 
		}
	 }
}






