
// register definitions

#ifndef _REGISTERS_H_
#define _REGISTERS_H_

#define BMCR		0x00	//Basic Mode Control Register 
#define BMSR		0x01	//Basic Mode Status Register 
#define ANAR		0x04	//Auto-Negotiation Advertisement Register 
#define PHYCR		0x19	//PHY Control Register
#define PHYSCR		0x11	//PHY Specific Control Register 
#define PDR	    	0x1f	//Power Down Register 
#define PHYSR	    0x10	//PHY Status Register 
#define REGCR	    0x0D	//Register Control Register
#define ADDAR	    0x0E	//Data Register
#define BISCR	    0x16	//BIST Control Register  
#define BISSR	    0x17	//BIST STATUS Register
#define B4	        0xB4	//analog register
#define B8	        0xB8	//analog register
#define BISPLR      0x7b    //BIST Packet Length Register
#define BISIPGR     0x7c    //BIST Inter Packet Gap Register
#define BISBCR      0x71    //BIST Byte Count Register
#define BISECR      0x72    //BIST Error Count Register
#define CDCR        0x1E    //Cable Diagnostic Registers
#define CDSR        0x1B    //Cable Diagnostic Status Register        
#define DSACR2      0xC27   //DSA Configuration Register 2 
#define CDPTC1R     0x0107  //CD Pre Test Configuration Control 1 
#define CDPTC2R     0x010F  //CD Pre Test Configuration Control 2 
#define CDRR        0x1C    //Cable Diagnostic Results Register
#define TDRCR       0xC01   //TDR Control Register
#define TDRLT3      0xC05   //TDR Low Threshold Register
#define TDRLT4      0xC06   //TDR Low Threshold Register
#define TDRHT1      0xC07   //TDR High Threshold Register
#define TDRHT2      0xC08   //TDR High Threshold Register
#define TDRHT3      0xC09   //TDR High Threshold Register
#define TDRHT4      0xC0A   //TDR High Threshold Register
#define TDRLCR1     0xC0B   //TDR Pattern Control Register 1
#define TDRSMR      0x80    //TDR State Machine Enable Register
#define TDRPAR      0x90    //TDR Pattern Amplitude Register
#define BICSR1      0x1B    //BIST Control and Status Register 1
#define BICSR2      0x1C    //BIST Control and Status Register 2
#define ALCD_1      0x155   //ALCD Control and results Register 1
#define ALCD_2      0x215   //ALCD results Register 2
#define ALCD_3      0x218   //ALCD results Register 3
#define TDR_1       0x170   //TDR configuration Register 1
#define TDR_2       0x171   //TDR configuration Register 2
#define TDR_3       0x172   //TDR configuration Register 3
#define TDR_4       0x173   //TDR configuration Register 4
#define TDR_5       0x174   //TDR configuration Register 5
#define TDR_6       0x175   //TDR configuration Register 6
#define TDR_7       0x176   //TDR configuration Register 7
#define TDR_8       0x177   //TDR configuration Register 8
#define TDR_9       0x178   //TDR configuration Register 9
#define CDLRR1      0x180   //Cable Diagnostic Location Results Register 1
#define CDLRR2      0x181   //Cable Diagnostic Location Results Register 2
#define CDLRR3      0x182   //Cable Diagnostic Location Results Register 3
#define CDLRR4      0x183   //Cable Diagnostic Location Results Register 4
#define CDLRR5      0x184   //Cable Diagnostic Location Results Register 5
#define CDARR1      0x185   //Cable Diagnostic Amplitude Results Register 1
#define CDARR2      0x186   //Cable Diagnostic Amplitude Results Register 2
#define CDARR3      0x187   //Cable Diagnostic Amplitude Results Register 3
#define CDARR4      0x188   //Cable Diagnostic Amplitude Results Register 4
#define CDARR5      0x189   //Cable Diagnostic Amplitude Results Register 5
#define CDGRR       0x18A   //Cable Diagnostic General Results Register
#define TXPCB       0xAE   //Cable Diagnostic General Results Register
#endif // _REGISTERS_H_