
/*
 *  reset function, initiates 3 diffrent resets:       
 *  
 * MII reset
 * Software reset
 * Digital reset
 * 
 *
 */


#include < stdio.h > 
#include < string.h >
#include "registers.h"
#include "read_write.h"
#include "status.h"




int reset_phy(int phy_id) // global + software reset to the chip
{
	  int error;
	  int bmcr_data, pdr_data;

	  bmcr_data = 0x8000 ;   //set bit 15 = 1 (MII reset)   		 
      error = phy_write(phy_id, BMCR, bmcr_data); //write
	  if (error < 0)
	  {		  
	      return error;
	  }

      pdr_data = 0xC000 ;   // set bit 15 = 1 (Software reset),set bit 14 to 1, digital reset 		 
      error = phy_write(phy_id, PDR, pdr_data); //write 
	  if (error < 0)
	  {		  
	      return error;
	  }
      

      return 0;
}






