
/*
 *
 *  Status (status.c): reads the status of the PHY:
 *  Link: up/ down
 *	Speed: 100BT / 10BT
 *	Duplex: full / half
 *	Pair swap: MDI / MDI-X / Auto_MDI
 *
 */


#include < stdio.h >
#include < string.h >
#include "registers.h"
#include "status.h"
#include "read_write.h"
#include "settings.h"





int status(int phy_id,status_phy *status_output)
{
   // variable declarations
   int error = 0;
   int link = 0x0;
   int speed = 0x0;
   int duplex = 0x0;
   int pair = 0x0;
   int physr_data=0;
   
   //status_phy status3;

	physr_data = phy_read(phy_id, PHYSR); // physr_data holds the value of PHYSR
	if (physr_data < 0)// error
	{
		return error = physr_data;
	}

	link = physr_data & 0x0001 ;   // bit 0 link_status
    speed = physr_data & 0x0002;   // bit 1
    duplex = physr_data & 0x0004;    // bit 2
    pair = physr_data & 0x4000;    // bit 14
    
    speed = speed >> 1; //shift right by 1
    duplex = duplex >> 2; //shift right by 2
    pair = pair >> 14; //shift right by 14
	
	status_output->link_status = link;
	status_output->speed_status = !speed; 
	status_output->duplex_status = duplex;
	status_output->pair_swap = pair;

	return 0;

}

